package cz.muni.pa165.generated.device_management.data.repository;

import cz.muni.pa165.generated.device_management.data.model.Device;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface DeviceRepository extends JpaRepository<Device, String> {
    Device save(Device device);

    @Query("SELECT d FROM Device d WHERE d.macAddress = :macAddress")
    Optional<Device> findByMAC(@Param("macAddress") String macAddress);

    @Query("SELECT d FROM Device d WHERE d.houseId = :houseId")
    List<Device> findByHouseId(@Param("houseId") String houseId);

    @Query("SELECT d FROM Device d WHERE d.houseId = :houseId ORDER BY d.createdAt DESC")
    List<Device> findByHouseIdSorted(String houseId, Pageable pageable);
}
