package cz.muni.pa165.generated.device_management.facade;

import cz.muni.pa165.generated.device_management.Service.DeviceService;
import cz.muni.pa165.generated.device_management.mapper.DeviceMapper;
import cz.muni.pa165.generated.device_management.model.DeviceResponse;
import cz.muni.pa165.generated.device_management.model.DeviceResponseList;
import cz.muni.pa165.generated.device_management.model.NewDevice;
import jakarta.transaction.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Transactional
public class DeviceFacadeImpl implements DeviceFacade {
    private final DeviceService deviceService;

    private final DeviceMapper deviceMapper;

    @Autowired
    public DeviceFacadeImpl(DeviceService service, DeviceMapper mapper) {
        deviceService = service;
        deviceMapper = mapper;
    }

    @Transactional
    public DeviceResponse createDevice(NewDevice newDevice) {
        return deviceMapper.mapToResponse(deviceService.createDevice(deviceMapper.mapToEntity(newDevice)));
    }

    @Transactional
    public DeviceResponse getDevice(String deviceId) {
        return deviceMapper.mapToResponse(deviceService.getDevice(deviceId));
    }

    @Transactional
    public DeviceResponse patchDevice(String deviceId, NewDevice newDevice) {
        return deviceMapper.mapToResponse(
                deviceService.updateDevice(deviceId, deviceMapper.mapToEntity(newDevice))
        );
    }

    @Transactional
    public void deleteDevice(String deviceId) {
        deviceService.deleteDevice(deviceId);
    }

    @Transactional
    public DeviceResponseList getDevicesByHouseId(String houseId) {
        return deviceMapper.mapToResponseList(deviceService.getDevicesByHouseId(houseId));
    }

    @Override
    public DeviceResponse getLastCreatedDeviceByHouseId(String houseId) {
        return deviceMapper.mapToResponse(deviceService.getLastCreatedDeviceByHouseId(houseId));
    }
}
