package cz.muni.pa165.generated.power_consumption.data.repository;

import cz.muni.pa165.generated.power_consumption.data.model.DeviceConsumption;
import cz.muni.pa165.generated.power_consumption.model.ConsumptionUnit;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.time.OffsetDateTime;
import java.util.List;
import java.util.Optional;

@Repository
public interface DeviceConsumptionRepository extends JpaRepository<DeviceConsumption, String> {

    Optional<DeviceConsumption> findById(@Param("id") String id);

    List<DeviceConsumption> findAll();

    @Query("SELECT c FROM DeviceConsumption c WHERE c.deviceMacAddress = ?1")
    List<DeviceConsumption> findByDeviceId(@Param("deviceMacAddress") String deviceMacAddress);

    @Query("SELECT distinct c.deviceMacAddress FROM DeviceConsumption c")
    List<String> findAllDevices();

    DeviceConsumption save(DeviceConsumption deviceConsumption);

    @Modifying
    @Query("UPDATE DeviceConsumption c SET c.deviceMacAddress = ?2, c.consumption = ?3, c.unit = ?4, c.dateTime = ?5 WHERE c.id = ?1")
    void update(String id, String deviceMacAddress, BigDecimal consumption, ConsumptionUnit unit, OffsetDateTime dateTime);

    void deleteById(String id);

    @Query("SELECT c FROM DeviceConsumption c WHERE c.deviceMacAddress = ?1 AND c.dateTime > ?2 AND c.dateTime < ?3")
    List<DeviceConsumption> findInInterval(String deviceId, OffsetDateTime from, OffsetDateTime to);
}