package cz.muni.pa165.generated.power_control;

import com.github.javafaker.Faker;
import cz.muni.pa165.generated.power_control.data.model.House;
import cz.muni.pa165.generated.power_control.data.repository.HouseRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.Random;
import java.util.UUID;

@Component
public class DataSeeder implements CommandLineRunner {
    Logger log = LoggerFactory.getLogger(DataSeeder.class);
    private final HouseRepository houseRepository;

    public DataSeeder(HouseRepository houseRepository) {
        this.houseRepository = houseRepository;
    }

    @Override
    public void run(String... args) throws Exception {
        if (houseRepository.count() == 0) {
            log.info("Seeding data");
            seedData();
        }
    }

    private void seedData() {
        for (int i = 0; i < 50; i++) {
            Faker faker = new Faker(new Random(i));
            String[] housePurposePool = {"home", "cottage", "beachhouse"};

            House house = new House();
            house.setName(housePurposePool[(new Random()).nextInt(housePurposePool.length)]);
            house.setAddress(faker.address().fullAddress());
            house.setEnabled(true);
            house.setOwnerId(UUID.randomUUID().toString());
            houseRepository.save(house);
        }
    }
}
