package cz.muni.pa165.generated.power_control;

import io.swagger.v3.oas.models.security.SecurityRequirement;
import io.swagger.v3.oas.models.security.SecurityScheme;
import org.springdoc.core.customizers.OpenApiCustomizer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpMethod;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configurers.oauth2.server.resource.OAuth2ResourceServerConfigurer;
import org.springframework.security.web.SecurityFilterChain;

@Configuration
public class SecurityConfig{
    @Bean
    SecurityFilterChain securityFilterChain(HttpSecurity http) throws Exception {
        http
                .authorizeHttpRequests(x -> x
                        .requestMatchers(HttpMethod.GET, "/api/house").hasAuthority("SCOPE_test_1")
                        .requestMatchers(HttpMethod.POST, "/api/house").hasAuthority("SCOPE_test_1")
                        .requestMatchers(HttpMethod.DELETE, "/api/house").hasAuthority("SCOPE_test_1")
                        .requestMatchers(HttpMethod.PATCH, "/api/house").hasAuthority("SCOPE_test_1")
                        .requestMatchers(HttpMethod.PATCH, "/api/house/switchPower").hasAuthority("SCOPE_test_1")
                        .requestMatchers(HttpMethod.GET, "/api/houses").hasAuthority("SCOPE_test_2")
                        .anyRequest().permitAll()
                )
                .oauth2ResourceServer(OAuth2ResourceServerConfigurer::opaqueToken);
        return http.build();
    }

    /**
     * Add security definitions to generated openapi.yaml.
     */
    @Bean
    public OpenApiCustomizer openAPICustomizer() {
        return openApi -> {
            openApi.getComponents().addSecuritySchemes("BearerAuth",
                    new SecurityScheme()
                            .scheme("bearer")
                            .type(SecurityScheme.Type.HTTP)
                            .description("OAuth2 Resource Server, provide a valid access token")
            );
            openApi.addSecurityItem(new SecurityRequirement().addList("BearerAuth"));
        };
    }
}