package cz.muni.pa165.generated.power_control.facade;

import cz.muni.pa165.generated.power_control.mappers.HouseMapper;
import cz.muni.pa165.generated.power_control.model.HouseResponse;
import cz.muni.pa165.generated.power_control.model.HouseResponseList;
import cz.muni.pa165.generated.power_control.model.NewHouse;
import cz.muni.pa165.generated.power_control.model.UpdateHouse;
import cz.muni.pa165.generated.power_control.service.HouseService;
import jakarta.transaction.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service
@Transactional
public class HouseFacadeImpl implements HouseFacade{
    private final HouseService houseService;
    private final HouseMapper houseMapper;

    @Autowired
    public HouseFacadeImpl(HouseService houseService, HouseMapper houseMapper) {
        this.houseService = houseService;
        this.houseMapper = houseMapper;
    }

    @Transactional
    public HouseResponse switchPower(String id) {
        return houseMapper.mapToDto(houseService.switchHousePower(id));
    }

    @Transactional
    public HouseResponseList getAllByOwnerId(String id) {
        return houseMapper.mapToList(houseService.getHousesByOwnerId(id));
    }

    @Transactional
    public HouseResponse create(NewHouse house) {
        return houseMapper.mapToDto(houseService.createHouse(house));
    }

    @Transactional
    public HouseResponse get(String id) {
        return houseMapper.mapToDto(houseService.getHouseById(id));
    }

    @Transactional
    public HouseResponse update(String id, UpdateHouse house) {
        return houseMapper.mapToDto(houseService.updateHouse(id, house));
    }

    @Transactional
    public void delete(String id) {
        houseService.deleteHouse(id);
    }

}
