package cz.muni.pa165.generated.power_control.mappers;

import cz.muni.pa165.generated.power_control.data.model.House;
import cz.muni.pa165.generated.power_control.model.HouseResponse;
import cz.muni.pa165.generated.power_control.model.HouseResponseList;
import org.mapstruct.Mapper;

import java.util.List;
import java.util.stream.Collectors;

/**
 * Interface for the House Mapper. This mapper is used to convert between House data objects and DTOs.
 */
@Mapper(componentModel = "spring")
public interface HouseMapper {

    /**
     * Converts a House object to a HouseResponse DTO.
     *
     * @param house the House object to be converted
     * @return a HouseResponse DTO representing the provided House object
     */
    HouseResponse mapToDto(House house);

    /**
     * Converts a List of House objects to a HouseResponseList DTO.
     *
     * @param houses the List of House objects to be converted
     * @return a HouseResponseList DTO containing HouseResponse DTOs representing the provided House objects
     */
    default HouseResponseList mapToList(List<House> houses) {
        var result = new HouseResponseList();
        result.setHouses(houses.stream().map(this::mapToDto).collect(Collectors.toList()));
        return result;
    }
}
