package cz.muni.pa165.generated.power_control;

import cz.muni.pa165.generated.power_control.data.model.House;
import cz.muni.pa165.generated.power_control.mappers.HouseMapperImpl;
import cz.muni.pa165.generated.power_control.model.HouseResponse;
import cz.muni.pa165.generated.power_control.model.HouseResponseList;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.junit.jupiter.MockitoExtension;

import java.util.ArrayList;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;

@ExtendWith(MockitoExtension.class)
public class HouseMapperTests {

    @InjectMocks
    private HouseMapperImpl houseMapper;

    @Test
    public void testMapToDto() {
        House house = new House()
                .setId("id")
                .setAddress("address")
                .setOwnerId("owner")
                .setName("name")
                .setEnabled(true);

        var expected = new HouseResponse()
                .id("id")
                .address("address")
                .ownerId("owner")
                .name("name")
                .enabled(true);

        HouseResponse houseResponse = houseMapper.mapToDto(house);

        assertEquals(expected, houseResponse);
    }

    @Test
    public void testMapToList() {
        List<House> houses = new ArrayList<>();
        var house1 = new House()
                .setId("id")
                .setAddress("address")
                .setOwnerId("owner")
                .setName("name")
                .setEnabled(true);
        houses.add(house1);

        var house2 = new House()
                .setId("id2")
                .setAddress("address2")
                .setOwnerId("owner2")
                .setName("name2")
                .setEnabled(false);
        houses.add(house2);

        var expected = new HouseResponseList();
        var responseHouse1 = new HouseResponse()
                .id("id")
                .address("address")
                .ownerId("owner")
                .name("name")
                .enabled(true);
        expected.addHousesItem(responseHouse1);

        var responseHouse2 = new HouseResponse()
                .id("id2")
                .address("address2")
                .ownerId("owner2")
                .name("name2")
                .enabled(false);
        expected.addHousesItem(responseHouse2);

        assertEquals(2, houses.size());

        HouseResponseList houseResponseList = houseMapper.mapToList(houses);

        assertNotNull(houseResponseList);
        assertNotNull(houseResponseList.getHouses());
        assertEquals(2, houseResponseList.getHouses().size());
        assertEquals(expected, houseResponseList);
    }
}

