package cz.muni.pa165.generated.user_management;

import com.github.javafaker.Faker;
import com.github.javafaker.Name;
import cz.muni.pa165.generated.user_management.models.User;
import cz.muni.pa165.generated.user_management.repositories.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Random;

@Component
public class DataSeeder implements CommandLineRunner {
    Logger log = LoggerFactory.getLogger(DataSeeder.class);

    private final UserRepository userRepository;

    private final PasswordEncoder passwordEncoder = new BCryptPasswordEncoder();

    public DataSeeder(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    @Override
    public void run(String... args) throws Exception {
        if (List.of(args).contains("--seed")) {
            log.info("Seeding data");
            seedData();
        }
    }

    private void seedData() {
        for (int i = 0; i < 50; i++) {
            Faker faker = new Faker(new Random(i));
            Name name = faker.name();
            User user = new User()
                    .setName(name.fullName())
                    .setEmail(name.username() + "@gmail.com")
                    .setPassword(passwordEncoder.encode(faker.letterify("????????")));
            userRepository.save(user);
        }
    }
}
